# Design Documents for Supported Features

Supported proposals describe functionality implemented and
released as fully supported features of the library. A fully supported feature
has a high-quality implementation, is regularly tested and properly documented.

If the proposal impacted the public API of the library, it should usually involve
changes in the oneDPL specification. The RFC document should, in that case,
have a link to the formal wording in the specification.

Proposals that appear in `rfcs/supported` may be retained indefinitely to
provide insight into the design of existing features. They could be updated
over time if the corresponding functionality is extended or modified.
